--[[
Not much needs to be done here, Blizzard actually did a damned fine job on this pane.

However, there is a small graphical bug that's bothered me. If you use the mouse to drag the thumb on the slider, you'll notice
that once it hits a certain point, the zebra stripes flicker oddly. This is because Blizzard is lazy, basically. =P

Anyways, this file is here to fix that.
]]--

-- This is the offset of the scroll child.
local scrollOffset = 0
-- This is the value of the slider thumb.
local sliderOffset = 0
TokenFrameContainer:HookScript("OnVerticalScroll", function(self, newScrollOffset)
	local newSliderOffset = TokenFrameContainerScrollBar:GetValue()
	-- Fun bit of logic here. The scrollOffset takes values on the interval [0,16).
	-- The stripes need to be flipped whenever the values wrap from one end to the other, and this one-liner covers that.
	-- Basically, use the delta in the thumb's value to give directionality to the comparison of the scroll offset.
	if (newSliderOffset > sliderOffset) == (newScrollOffset < scrollOffset) then
		for _, button in pairs(self.buttons) do
			if button.stripe:IsShown() then
				button.stripe:Hide()
			else
				button.stripe:Show()
			end
		end
	end
	sliderOffset = newSliderOffset
	scrollOffset = newScrollOffset
end)