local name, addon = ...;
local L = addon.L

local tl, tr, bl, br, div1, div2 = SkillFrame:GetRegions() -- Only need the first four returns here, the textures backing the Frame
tl:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft")
tl:SetPoint("TOPLEFT",2,-1)
tr:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight")
tr:SetPoint("TOPLEFT",258,-1)
bl:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomLeft")
bl:SetPoint("TOPLEFT",2,-257)
br:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-BottomRight")
br:SetPoint("TOPLEFT",258,-257)
div1:Hide()
div2:Hide()

for _,v in pairs({SkillFrameCollapseAllButton:GetParent(), SkillListScrollFrame, SkillFrameCancelButton, SkillDetailScrollFrame}) do
	v:Hide()
	v:HookScript("OnShow", function(self) self:Hide() end)
end
for i=1,SKILLS_TO_DISPLAY do -- Note: That's a Blizzard global there.
	_G["SkillRankFrame"..i]:Hide()
	_G["SkillRankFrame"..i]:HookScript("OnShow", function(self) self:Hide() end)
	_G["SkillTypeLabel"..i]:Hide()
	_G["SkillTypeLabel"..i]:HookScript("OnShow", function(self) self:Hide() end)
end



local NUMROWS, ROWHEIGHT, ROWWIDTH = 18, 19.5, 315
local CE_Skills = CreateFrame("Frame", "CE_Skills", SkillFrame)
CE_Skills:SetWidth(ROWWIDTH) -- Consider a better way to do this
CE_Skills:SetHeight(NUMROWS*ROWHEIGHT)
CE_Skills:SetPoint("TOPLEFT", 21, -77)
local professionsLabel = SkillFrame:CreateFontString(nil,nil, "GameFontHighlight")
professionsLabel:SetText(TRADE_SKILLS)
professionsLabel:SetPoint("TOP", SkillFrame, "TOP", -12, -56)
CE_Skills:Hide()

local CreateSeparator
do
	local count = 1
	CreateSeparator = function(yOff)
		local separator = CE_Skills:CreateTexture("CE_SkillsSeparator"..count, "BACKGROUND")
		separator:SetWidth(331)
		separator:SetHeight(29)
		separator:SetTexture("Interface\\PVPFrame\\UI-Character-PVP")
		separator:SetTexCoord(2/512, 333/512, 91/512, 120/512)
		separator:SetPoint("TOPLEFT", CE_Skills, "TOPLEFT", -4, -yOff)
		local label = CE_Skills:CreateFontString(nil, nil, "GameFontHighlight")
		label:SetPoint("CENTER", separator, "CENTER")
		separator.label = label
		count = count + 1
		return separator
	end
end

local buttons = {}
for i=1,6 do
	local button = CreateFrame("CheckButton", "CE_ProfessionButton"..i, CE_Skills, "ActionButtonTemplate, SecureActionButtonTemplate")
	button:SetAttribute("type", "spell")
	button:RegisterForClicks("AnyUp")
	button:SetScript("OnEnter", function(self, motion)
					GameTooltip_SetDefaultAnchor(GameTooltip, self)
					if self.link then
						GameTooltip:SetHyperlink(self.link)
					else
						GameTooltip:SetText(self.action, 1, 1, 0.7)
					end
					GameTooltip:AddLine(self.descrip, 1, 1, 1, true)
					GameTooltip:Show()
			    end)
	button:SetScript("OnLeave", function()
					GameTooltip:Hide()
			    end)
	button:RegisterEvent("TRADE_SKILL_SHOW");
	button:RegisterEvent("TRADE_SKILL_CLOSE");
	button:RegisterEvent("CURRENT_SPELL_CAST_CHANGED");
	button:SetScript("OnEvent", function(self)
					if TradeSkillFrameTitleText and TradeSkillFrameTitleText:GetText() == self.action and TradeSkillFrame:IsShown() then
						self:SetChecked(1);
					else
						self:SetChecked(0);
					end
				end)
	button:RegisterForDrag("LeftButton","RightButton")
	button:SetScript("OnDragStart", function(self)
					if not InCombatLockdown() then
						PickupSpell(self.action)
					end
				end)
	local Name = button:CreateFontString(nil, nil, "GameFontHighlight")
	Name:SetPoint("TOPLEFT", button, "TOPRIGHT", 4, 0)
	button.Name = Name
	local Rank = button:CreateFontString(nil, nil, "GameFontDisableSmall")
	Rank:SetPoint("TOPLEFT", Name, "BOTTOMLEFT")
	button.Rank = Rank
	local Frac = button:CreateFontString(nil, nil, "GameFontDisableSmall")
	Frac:SetPoint("TOPLEFT", Rank, "BOTTOMLEFT")
	button.Frac = Frac
	
	button.Icon = _G["CE_ProfessionButton"..i.."Icon"]
	
	local UnlearnButton = CreateFrame("Button", nil, button)
	UnlearnButton:SetPoint("LEFT", button.Frac, "RIGHT", 4, -1)
	UnlearnButton:SetWidth(20)
	UnlearnButton:SetHeight(20)
	UnlearnButton:SetNormalTexture("Interface\\Buttons\\CancelButton-Up")
	UnlearnButton:SetPushedTexture("Interface\\Buttons\\CancelButton-Down")
	UnlearnButton:SetHighlightTexture("Interface\\Buttons\\CancelButton-Highlight")
	UnlearnButton:Hide()
	button.unlearn = UnlearnButton
	if i == 1 then
		button:SetPoint("TOPLEFT", CE_Skills, "TOPLEFT", 16, -6)
	elseif i == 2 then
		button:SetPoint("TOPLEFT", CE_Skills, "TOP", 16, -6)
	else
		Name:SetPoint("TOPLEFT", button, "TOPRIGHT", 4, -5)
		button:SetScale(0.8)
		local s = button:GetEffectiveScale()
		button.Rank:Hide()
		button.Frac:SetPoint("TOPLEFT", Name, "BOTTOMLEFT", 0, -2)
		button:SetPoint("TOPLEFT", CE_Skills, "TOPLEFT", (CE_Skills:GetWidth()*(i-3)/4 + 8)/s, -52/s)
	end
	buttons[i] = button
	button:Disable()
end

local function ResetButtons()
	for _, v in ipairs(buttons) do
		v.link = nil
		v.action = nil
		v.descrip = nil
		v.Name:SetText("")
		v.Rank:SetText("")
		v.Frac:SetText("")
		v.unlearn:Hide()
		v.Icon:SetTexture("")
		v:Disable()
	end
end
CreateSeparator(88)
CE_SkillsSeparator1.label:SetText(L["Weapon Skills"])

-- local wpnSkillIcons = {
	-- [L["Bows"]] 				= "inv_weapon_bow_05",
	-- [L["Crossbows"]]			= "inv_weapon_crossbow_01",
	-- [L["Daggers"]] 				= "ability_steelmelee",
	-- [L["Fist Weapons"]]			= "inv_gauntlets_04",
	-- [L["Guns"]]					= "inv_weapon_rifle_01",
	-- [L["Axes"]]					= "inv_axe_01",
	-- [L["Maces"]]				= "inv_mace_01",
	-- [L["Swords"]]				= "ability_meleedamage",
	-- [L["Polearms"]]				= "inv_spear_06",
	-- [L["Staves"]]				= "inv_staff_08",
	-- [L["Thrown"]]				= "inv_throwingknife_02",
	-- [L["Two-Handed Axes"]]		= "inv_axe_04",
	-- [L["Two-Handed Maces"]]		= "inv_mace_04",
	-- [L["Two-Handed Swords"]]	= "ability_meleedamage",
	-- [L["Unarmed"]]				= "ability_golemthunderclap",
	-- [L["Defense"]]				= "ability_racial_shadowmeld",
-- }

local ridingSpells = {
	[75]	= 33388,
	[150]	= 33391,
	[225]	= 34090,
	[300]	= 34091,
}
	
local bars = {}
for i=1,16 do
	local bar = CreateFrame("StatusBar", "CE_WeaponSkill"..i, CE_Skills)
	local Label = bar:CreateFontString(nil, nil, "GameFontHighlightSmall")
	-- Label:SetFont("Fonts\\FRIZQT__.TTF",11)
	bar.Label = Label
	local Rank = bar:CreateFontString(nil, nil, "GameFontDisableSmall")
	bar.Rank = Rank
	Label:SetPoint("BOTTOMLEFT", bar, "TOPLEFT", 0, 4)
	-- Rank:SetPoint("BOTTOMRIGHT", bar, "TOPRIGHT", 0, 4)
	Rank:SetPoint("CENTER", bar, "CENTER", 0, 2)
	
	bar:SetWidth(CE_Skills:GetWidth()/2 - 12)
	bar:SetHeight(12)
	bar:SetStatusBarTexture([[Interface\PaperDollInfoFrame\UI-Character-Skills-Bar]])
	bar:SetStatusBarColor(0.25, 0.25, 0.75)
	
	bar:EnableMouse(true)
	bar:SetScript("OnEnter", function(self)
					GameTooltip_SetDefaultAnchor(GameTooltip, self)
					self.Rank:SetAlpha(0.4)
					GameTooltip:SetText(self.skillName)
					GameTooltip:AddLine(self.descrip, 1, 1, 1, true)
					GameTooltip:Show()
			    end)
	bar:SetScript("OnLeave", function(self)
					self.Rank:SetAlpha(1.0)
					GameTooltip:Hide()
			    end)
	local Outline = bar:CreateTexture(nil, "OVERLAY")
	Outline:SetTexture([[Interface\PaperDollInfoFrame\UI-Character-Skills-BarBorder]])
	Outline:SetHeight(bar:GetHeight()+17)
	Outline:SetWidth(bar:GetWidth()+8)
	Outline:SetPoint("LEFT", bar, "LEFT", -5, 0)
	bar.Outline = Outline
	if i == 1 then
		bar:SetPoint("TOPLEFT", CE_Skills, "TOPLEFT", 8, -134)
	elseif i == 2 then
		bar:SetPoint("TOPRIGHT", CE_Skills, "TOPRIGHT", -4, -134)
	else
		bar:SetPoint("TOPLEFT", bars[i-2], "BOTTOMLEFT", 0, -17)
	end
	bars[i] = bar
	bar:Hide()
end

local function SetUpButton(pNum, skillName, skillRank, skillMod, skillMax, isPrimary, description, i)
	local button = buttons[pNum]
	-- print(format("Setting up %s on button %d",skillName,pNum))
	button.Name:SetText(skillName)
	
	-- GetSpell = lookup skillName
	button.link = GetSpellLink(skillName)
	local _, rank, icon = GetSpellInfo(skillName)
	if not rank or IsPassiveSpell(skillName) then
		button:Disable()
	end
	if button.link then
		button:Enable()
	end	
	
	button.action = skillName
	button.Rank:SetText(rank)
	local space, color = " "
	if pNum > 2 then
		space = ""
	end
	if skillMod > 0 then
		color = "|cff20ff20"
	elseif skillMod <0 then
		color = "|cffff2020"
	elseif skillRank ~= skillMax then
		color = "|cffffffff"
	else
		color = ""
	end
	button.Frac:SetFormattedText("%s%d|r%s/%s%d", color, skillRank+skillMod, space, space, skillMax)
	button:SetAttribute("spell", skillName)
	
	-- Riding needs to show as passive, but that ain't easy...
	if skillName == L["Riding"] then
		icon = "Interface\\Icons\\Spell_Nature_Swiftness"
		button.link = GetSpellLink(ridingSpells[skillRank])
		-- Duplicate the look n feel of a "passive spell button"
		button:SetCheckedTexture([[Interface\Buttons\UI-Quickslot2]])
		button:SetHighlightTexture([[Interface\Buttons\UI-Quickslot2]])
	else
		button:SetCheckedTexture([[Interface\Buttons\CheckButtonHilight]])
		button:SetHighlightTexture([[Interface\Buttons\ButtonHilight-Square]])
	end
	
	button.Icon:SetTexture(icon)
	button.descrip = description
			
	if pNum <= 2 then
		button.pNum = i
		button.unlearn:Show()
		button.unlearn:SetScript("OnClick", function(self, button)
			local dialog = StaticPopup_Show("UNLEARN_SKILL", self:GetParent().action);
			if ( dialog ) then
				dialog.data = self:GetParent().pNum
			end
		end)
		button.unlearn:SetScript("OnEnter", function(self)
			GameTooltip:SetOwner(self,"ANCHOR_RIGHT")
			GameTooltip:SetText(L["Click here to unlearn this profession."])
			GameTooltip:AddLine(L["You will be prompted for confirmation."])
			GameTooltip:Show()
		end)
		button.unlearn:SetScript("OnLeave", function(self)
			GameTooltip:Hide()
		end)
	end
end

local lock = false
local function Refresh()
	if lock then return end
	lock = true
	local skillName, header, _,  skillRank, _, skillModifier, skillMaxRank, isAbandonable, _,  _, _, _,  skillDescription
	local rank, icon, lastHeader, button, bar
	local pNum, wNum = 1, 1
	
	ExpandSkillHeader(0)
	ResetButtons()
	for i=1, GetNumSkillLines() do
		skillName, header, _,  skillRank, _, skillModifier, skillMaxRank, isAbandonable, _,  _, _, _,  skillDescription = GetSkillLineInfo(i)
		if header then
			lastHeader = skillName
		elseif lastHeader == L["Professions"] or lastHeader == L["Secondary Skills"] then
			if (not isAbandonable) and pNum <= 2 then
				pNum = 3
			end
			SetUpButton(pNum, skillName, skillRank, skillModifier, skillMaxRank, isAbandonable, skillDescription, i)
			pNum = pNum + 1
		elseif lastHeader == L["Weapon Skills"] then
			bar = bars[wNum]
			bar.skillName = skillName
			bar:SetMinMaxValues(0, skillMaxRank)
			if (skillRank + skillModifier) < skillMaxRank then
				bar:SetValue(skillRank + skillModifier)
			else
				bar:SetValue(skillMaxRank)
			end
	
			bar.Label:SetText(skillName)
				local color
				if skillModifier > 0 then
					color = "|cff20ff20"
				elseif skillModifier <0 then
					color = "|cffff2020"
				elseif skillRank ~= skillMaxRank then
					color = "|cffffffff"
				else
					color = ""
				end
				bar.Rank:SetFormattedText("%s%d|r / %d", color, skillRank+skillModifier, skillMaxRank)
			bar.descrip = skillDescription
			wNum = wNum + 1
			bar:Show()
		end
	end
	lock = false
end


hooksecurefunc(SkillFrame, "Show", function()
	CE_Skills:Show()
end)

CE_Skills:RegisterEvent("SKILL_LINES_CHANGED")
CE_Skills:RegisterEvent("CHAT_MSG_SKILL")
CE_Skills:SetScript("OnEvent", function()
	Refresh()
end)